//+------------------------------------------------------------------+
//|                                              Label indicator.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property copyright "Copyright 2012, Fausto Del Gaudio"
#property link      "thefxpros@katamail.com"


#property indicator_chart_window

   extern int    FontSizeLBL1  = 18;            //Dimensione font label 1
   extern color  FontColorLBL1 = Black;         //Colore font label 1
   extern string FontTypeLBL1  = "Tahoma";      //Tipo font label 1
   extern int    FontSizeLBL2  = 12;            //Dimensione font label 2
   extern color  FontColorLBL2 = Green;         //Colore font label 2
   extern string FontTypeLBL2  = "Arial";       //Tipo font label 2
   extern int    Corner        = 1;             //Angolo di posizionamento
   extern int    XposLBL1      = 10;            //Posizione X label 1
   extern int    YposLBL1      = 10;           //Posizione Y label 1
   extern int    XposLBL2      = 10;            //Posizione X label 2
   extern int    YposLBL2      = 40;           //Posizione Y label 2
  // extern string Text1         = "Text1";       //Testo label 1
   extern string Text2         = "";       //Testo label 2


//--------------------------------


int init()
  {

   return(0);
  }


//--------------------------------


int deinit()
  {
  
   ObjectDelete("Label_Ind1");
   ObjectDelete("Label_Ind2");
      
   
   return(0);
  }


//---------------------------------

int start()
  {
  
      ObjectCreate("Label_Ind1", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("Label_Ind1", Symbol(), FontSizeLBL1, FontTypeLBL1, FontColorLBL1);
      ObjectSet("Label_Ind1", OBJPROP_CORNER, Corner);
      ObjectSet("Label_Ind1", OBJPROP_XDISTANCE, XposLBL1);
      ObjectSet("Label_Ind1", OBJPROP_YDISTANCE, YposLBL1);
      
      ObjectCreate("Label_Ind2", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("Label_Ind2", Text2, FontSizeLBL2, FontTypeLBL2, FontColorLBL2);
      ObjectSet("Label_Ind2", OBJPROP_CORNER, Corner);
      ObjectSet("Label_Ind2", OBJPROP_XDISTANCE, XposLBL2);
      ObjectSet("Label_Ind2", OBJPROP_YDISTANCE, YposLBL2);
      
   return(0);
  }
//+------------------------------------------------------------------+