//+------------------------------------------------------------------+
//|                                     Alexander moving average.mq4 |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  Black
#property indicator_width1  2

//
//
//
//
//

extern int  Length = 7;
extern int  Price  = PRICE_CLOSE;

//
//
//
//
//

double buffer1[];
double buffer2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   Length = MathMax(Length,4);
      IndicatorBuffers(2);
         SetIndexBuffer(0,buffer1);
         SetIndexBuffer(1,buffer2);
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(MathMax(Bars-counted_bars,7),Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      buffer2[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      
      //
      //
      //
      //
      //
      
      double sump = 0;
      double sumw = 0;
         for(int k=0; k<Length; k++)
         {
            //
            //
            //    weight for penultimate element is always 0. It is correct, but in order to avoid one more if...
            //    left it so in order to keep the code as simple as posible - the result is the same. with or
            //    without additional if, and the speed is not going to change much
            //
            //
            
            double weight = Length-k-2;
                   sump += weight*buffer2[i+k];
                   sumw += weight;
         }
         if (sumw!=0)
               buffer1[i] = sump/sumw;
         else  buffer1[i] = 0;
   }            
   return(0);
}