//+------------------------------------------------------------------+
//|                                                         dema.mq4 | 
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  LimeGreen
#property indicator_width1 2
//
//
//
//
//

extern int  TEMAPeriod = 26;
extern int  TEMAPrice  = PRICE_CLOSE;

//
//
//
//
//

double tema[];
double tBuffer[][3];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,tema);   
   IndicatorShortName("MA - tema");
return(0);
}

int deinit()  {   return(0);  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(tBuffer,0) != Bars) ArrayResize(tBuffer,Bars);


   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--) tema[i] = iTema(iMA(NULL,0,1,0,MODE_SMA,TEMAPrice,i),TEMAPeriod,i,0);
         
return(0);
}
     
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iTema(double price,int period,int shift,int forBuffer)
{
   double alpha = 2.0 /(1.0 + period);
   int i = Bars-shift-1;
   if (i < 1)
      {
         tBuffer[i][0+forBuffer] = price;
         tBuffer[i][1+forBuffer] = price;
         tBuffer[i][2+forBuffer] = price;
      }
   else
      {
         tBuffer[i][0+forBuffer] = tBuffer[i-1][0+forBuffer]+alpha*(price                  -tBuffer[i-1][0+forBuffer]);
         tBuffer[i][1+forBuffer] = tBuffer[i-1][1+forBuffer]+alpha*(tBuffer[i][0+forBuffer]-tBuffer[i-1][1+forBuffer]);
         tBuffer[i][2+forBuffer] = tBuffer[i-1][2+forBuffer]+alpha*(tBuffer[i][1+forBuffer]-tBuffer[i-1][2+forBuffer]);
      }
   return(3*tBuffer[i][0+forBuffer] - 3*tBuffer[i][1+forBuffer] + tBuffer[i][2+forBuffer]);
}