
#property copyright "Copyright  2009, the Guru Online."
#property link      "http://www.theguruonline.biz"

#property indicator_chart_window

string gs_76 = "Pip tracker";
string gs_84 = "1.1";
extern int Display_Corner   = 3;
extern int Display_X_Offset = 260;
extern int Display_Y_Offset = 150;
extern string StartDate     = "yyyy.mm.dd hh:mm";
extern color Symbol_clr     = Goldenrod;
extern color Text_clr       = Black;
extern color Dn_clr         = FireBrick;
extern color Up_clr         = LimeGreen;
extern color Stats_clr      = DarkGray;
extern color BuyStats_clr   = LimeGreen;
extern color SellStats_clr  = FireBrick;

int var_a;
bool var_b;
int var_c = 0;
int var_d = 1;

int init() {
   IndicatorShortName("Pip tracker");
   if (Digits == 3 || Digits == 5) var_d = 10 * var_d;
   if (StartDate == "yyyy.mm.dd hh:mm") var_a = iTime(Symbol(), PERIOD_D1, 0);
   else var_a = StrToTime(StartDate);
   
   if (var_d == 1) _Draw_Label(Display_X_Offset + 74, Display_Y_Offset + 55, 13, "All " + Symbol() + " Trades", "0", Text_clr, "Tahoma", -1, 0);
   else _Draw_Label(Display_X_Offset + 74, Display_Y_Offset + 55, 13, "All " + Symbol() + " Trades", "0.0", Symbol_clr, "Tahoma", -1, 0);
   return (0);
}

int deinit() {
   string l_name_8;
   int l_objs_total_0 = ObjectsTotal();
   for (int l_objs_total_4 = l_objs_total_0; l_objs_total_4 >= 0; l_objs_total_4--) {
      l_name_8 = ObjectName(l_objs_total_4);
      if (StringSubstr(l_name_8, 0, StringLen(gs_76) + 2) == "[" + gs_76 + "]") ObjectDelete(l_name_8);
   }
   return (0);
}

int start() {
   int var_e;
   bool var_f;
   var_b = FALSE;
  
   _Draw_Label(Display_X_Offset + 44, Display_Y_Offset + 145, 12, Symbol(), Symbol(), Symbol_clr, "Tahoma", -1, 0);
   _Draw_Label(Display_X_Offset + 38, Display_Y_Offset + 93, 8, "Trades Since1", "|", Stats_clr, "Tahoma", -1, 0);
   _Draw_Label(Display_X_Offset + 104, Display_Y_Offset + 93, 8, "Trades Since2", "|", Stats_clr, "Tahoma", -1, 0);
   _Draw_Label(Display_X_Offset + 38, Display_Y_Offset + 83, 8, "Trades Since3", "|", Stats_clr, "Tahoma", -1, 0);
   _Draw_Label(Display_X_Offset + 104, Display_Y_Offset + 83, 8, "Trades Since4", "|", Stats_clr, "Tahoma", -1, 0);
   _Draw_Label(Display_X_Offset + 32, Display_Y_Offset + 75, 10, "Separator", "____________", Text_clr, "Tahoma", -1, 0);
   _Draw_Label(Display_X_Offset + 45, Display_Y_Offset + 82, 8, "Start Date", TimeToStr(var_a,TIME_DATE), Stats_clr, "Tahoma", -1, 0);
   _Draw_Label(Display_X_Offset + 46, Display_Y_Offset + 94, 8, "Stats since", "stats since", Stats_clr, "Tahoma", -1, 0);
   
   
   double var_g = 0;
   double var_h = 0;
   double var_i = 0;
   int var_l = 0;
   int var_m = 0;
   int var_n = 0;
   int var_o = 0;
   int var_p = 0;
   int var_q = 0;
   int var_r = 0;
   int var_s = 0;
   int var_t = Text_clr;
   if (OrdersTotal() != 0) {
      var_f = FALSE;
      for (int l_pos_24 = 0; l_pos_24 < OrdersTotal(); l_pos_24++) {
         var_e = 1;
         if (OrderSelect(l_pos_24, SELECT_BY_POS, MODE_TRADES) == FALSE) {
            Print("Access to orders failed with error (", GetLastError(), ")");
            break;
         }
         if (MarketInfo(OrderSymbol(), MODE_DIGITS) == 3.0 || MarketInfo(OrderSymbol(), MODE_DIGITS) == 5.0) var_e = 10;
         if (OrderType() == OP_BUY && OrderOpenTime() >= var_a) {
            var_m++;
            if (OrderProfit() >= 0.0) var_o++;
            var_h += (OrderClosePrice() - OrderOpenPrice()) / MarketInfo(OrderSymbol(), MODE_POINT) / var_e;
            if (OrderSymbol() == Symbol()) {
               var_l++;
               if (OrderProfit() >= 0.0) var_n++;
               var_f = TRUE;
               var_i += OrderLots();
               var_g += (OrderClosePrice() - OrderOpenPrice()) / MarketInfo(OrderSymbol(), MODE_POINT) / var_e;
            }
         } else {
            if (OrderType() == OP_SELL && OrderOpenTime() >= var_a) {
               var_q++;
               if (OrderProfit() >= 0.0) var_s++;
               var_h += (OrderOpenPrice() - OrderClosePrice()) / MarketInfo(OrderSymbol(), MODE_POINT) / var_e;
               if (OrderSymbol() == Symbol()) {
                  var_p++;
                  if (OrderProfit() >= 0.0) var_r++;
                  var_f = TRUE;
                  var_i -= OrderLots();
                  var_g += (OrderOpenPrice() - OrderClosePrice()) / MarketInfo(OrderSymbol(), MODE_POINT) / var_e;
               }
            }
         }
      }
   }
   
   if (OrdersHistoryTotal() != 0) {
      for (l_pos_24 = 0; l_pos_24 < OrdersHistoryTotal(); l_pos_24++) {
         var_e = 1;
         if (OrderSelect(l_pos_24, SELECT_BY_POS, MODE_HISTORY) == FALSE) {
            Print("Access to orders failed with error (", GetLastError(), ")");
            break;
         }
         if (MarketInfo(OrderSymbol(), MODE_DIGITS) == 3.0 || MarketInfo(OrderSymbol(), MODE_DIGITS) == 5.0) var_e = 10;
         if (OrderType() == OP_BUY && OrderOpenTime() >= var_a) {
            var_m++;
            if (OrderProfit() >= 0.0) var_o++;
            var_h += (OrderClosePrice() - OrderOpenPrice()) / MarketInfo(OrderSymbol(), MODE_POINT) / var_e;
            if (OrderSymbol() == Symbol()) {
               var_l++;
               if (OrderProfit() >= 0.0) var_n++;
               var_g += (OrderClosePrice() - OrderOpenPrice()) / MarketInfo(OrderSymbol(), MODE_POINT) / var_e;
            }
         } else {
            if (OrderType() == OP_SELL && OrderOpenTime() >= var_a) {
               var_q++;
               if (OrderProfit() >= 0.0) var_s++;
               var_h += (OrderOpenPrice() - OrderClosePrice()) / MarketInfo(OrderSymbol(), MODE_POINT) / var_e;
               if (OrderSymbol() == Symbol()) {
                  var_p++;
                  if (OrderProfit() >= 0.0) var_r++;
                  var_g += (OrderOpenPrice() - OrderClosePrice()) / MarketInfo(OrderSymbol(), MODE_POINT) / var_e;
               }
            }
         }
      }
      var_t = Text_clr;
     
      if (var_g > 0.0) var_t = Up_clr;
      else
         if (var_g < 0.0) var_t = Dn_clr;
      if (var_d == 1) _Draw_Label(Display_X_Offset + 80, Display_Y_Offset + 55, 12, "All " + Symbol() + " Trades", DoubleToStr(var_g, 0), var_t, "Tahoma", -1, 0);
      else _Draw_Label(Display_X_Offset + 74, Display_Y_Offset + 55, 12, "All " + Symbol() + " Trades", DoubleToStr(var_g, 1), var_t, "Tahoma", -1, 0);
   }
      
   _Draw_Label(Display_X_Offset + 45, Display_Y_Offset + 111, 8, "Long", "Long", Text_clr, "Tahoma", -1, 0);
   _Draw_Label(Display_X_Offset + 80, Display_Y_Offset + 111, 8, "Buy Wins", var_n + "/" + var_l, BuyStats_clr, "Tahoma", -1, 0);   
   _Draw_Label(Display_X_Offset + 43, Display_Y_Offset + 125, 8, "Short", "Short", Text_clr, "Tahoma", -1, 0);
   _Draw_Label(Display_X_Offset + 80, Display_Y_Offset + 125, 8, "Sell Wins", var_r + "/" + var_p, SellStats_clr, "Tahoma", -1, 0);
   _Draw_Label(Display_X_Offset + 37, Display_Y_Offset + 56,  11, "Pips", "Pips", Text_clr, "Tahoma", -1, 0);
   
   return (0);
}

void _Draw_Label(int a_x_0, int a_y_4, int a_fontsize_8, string as_12, string a_text_20, color a_color_28, string a_fontname_32, int a_corner_40 = -1, int a_window_44 = -1) {
   if (a_corner_40 == -1) a_corner_40 = Display_Corner;
   if (a_window_44 == -1) a_window_44 = var_b;
   ObjectDelete("[" + gs_76 + "] " + as_12);
   ObjectCreate("[" + gs_76 + "] " + as_12, OBJ_LABEL, a_window_44, 0, 0);
   ObjectSetText("[" + gs_76 + "] " + as_12, a_text_20, a_fontsize_8, a_fontname_32, a_color_28);
   ObjectSet("[" + gs_76 + "] " + as_12, OBJPROP_BACK, TRUE);
   ObjectSet("[" + gs_76 + "] " + as_12, OBJPROP_CORNER, a_corner_40);
   ObjectSet("[" + gs_76 + "] " + as_12, OBJPROP_XDISTANCE, a_x_0);
   ObjectSet("[" + gs_76 + "] " + as_12, OBJPROP_YDISTANCE, a_y_4);
}