//+------------------------------------------------------------------+
//|                                                       Spread.mq4 |
//|                                  Copyright  2009, Andriy Moraru |
//+------------------------------------------------------------------+
//|                                                     spreader.mq4 |
//|                    Copyright  2008, syanwar (www.viking234.com) |
//|                                              admin@viking234.biz |
//+------------------------------------------------------------------+
//|   Lot, Swapp Added,Combine n edit by cmkm-2011-(Thhudu@yahoo.com)|
//+------------------------------------------------------------------+
#property copyright " Combine n edit by cmkm-2011-(Thhudu@yahoo.com)"

#property indicator_chart_window

//---- alert
extern int    __________Alert_Spread = 500;
//---- alert
extern bool ___Show_Swap = False;
extern int corner = 2; //0 ,1 ,2 ,3
extern double Lot=1;
extern string Pip_Value_Of_Lot="Lot = 1 ( MinLot )";
extern int nPip=1;

bool normalize = true; //If true then the spread is normalized to traditional pips
color font_color = Black;
string font = "Tahoma";
int font_size = 7;

double Poin;
int n_digits = 0;
double divider = 1;

//+-----------------------------------------+
int init()
{
   //Checking for unconvetional Point digits number
   if (Point == 0.00001) Poin = 0.0001; //5 digits
   else if (Point == 0.001) Poin = 0.01; //3 digits
   else Poin = Point; //Normal
   
   ObjectCreate("Spread", OBJ_LABEL, 0, 0, 0);
   ObjectSet("Spread", OBJPROP_CORNER, corner);
   ObjectSet("Spread", OBJPROP_XDISTANCE, 5);
   ObjectSet("Spread", OBJPROP_YDISTANCE, 5);
   double spread = MarketInfo(Symbol(), MODE_SPREAD);
   
   if ((Poin > Point) && (normalize))
   {
      divider = 10.0;
      n_digits = 1;
   }
   
   return(0);
}
//+-----------------------------------------+

int deinit()
{
   ObjectDelete("Spread");
   ObjectDelete("Swap");

   return(0);
}
//+-----------------------------------------+

int start()
{     
//--------Lot-------
   double MinLot =MarketInfo(Symbol(), MODE_MINLOT);
   if (Lot<=MinLot){Lot=MinLot;}
   //-----Lot digits----
   int Lot_digits = 1;
   if (Lot<0.1){Lot_digits=2;}
   
//--------Pip-Lot-------

   double Pip_Lot=MarketInfo(Symbol(), MODE_TICKVALUE)/10;
   if (Lot<=MinLot){ Pip_Lot=Pip_Lot;}
     else{Pip_Lot=Pip_Lot*Lot/MinLot;}
     
//--------Spread n Pip Value-------  
   RefreshRates();
   double Account= AccountEquity();
   double spread = (Ask - Bid) / Point;

   ObjectSetText("Spread", "Spread = " + DoubleToStr(NormalizeDouble(spread / divider, 1), n_digits )+ " pips"+
                 " | "+nPip+" Pip = " + DoubleToStr(Pip_Lot*nPip,1)+ "  ( "+        //Pip value
                 DoubleToStr((Pip_Lot*nPip)*100/Account,1)+" % Acc) [ "+          //% Account
                 DoubleToStr(Lot,Lot_digits)+" Lot ]", font_size, font, font_color);  //Of Lot
    
//--------alert-------
       int Spread_digit=NormalizeDouble(spread / divider, 1), n_digits;

       if(Spread_digit > __________Alert_Spread) {
       Alert(Symbol()+"  spread=  "+Spread_digit);}
//--------Swap-------
  if (___Show_Swap==true) { // on/off show swap (only this line)
   ObjectCreate("Swap", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Swap","Swap Long =  "+DoubleToStr(MarketInfo(Symbol(), MODE_SWAPLONG),1)+ " "+
                 "   |  Swap Short =  "+DoubleToStr(MarketInfo(Symbol(), MODE_SWAPSHORT),1)+ " ", font_size, font, White);
   ObjectSet("Swap", OBJPROP_CORNER, corner);
   ObjectSet("Swap", OBJPROP_XDISTANCE, 5);
   ObjectSet("Swap", OBJPROP_YDISTANCE, 32); }
//+-----------------------------------------+
return(0);
}